note
	description: "Summary description for {LEGRAND_14668}."
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	LEGRAND_14668

inherit
	MEASURING_POINT_CSV

create
	make

feature -- Access

	header_row_index: INTEGER = 1

feature -- Parsing

	process_row (a_csv_row: DS_ARRAYED_LIST [STRING])
			-- data: { "action": { "feature": "import_from_sit_csv_legrand_14668", "arg1": "/tmp/solarity/solarity/2019/4/20190404_b8-27-eb-17-33-21_192.168.0.45_legrand_145671.py.csv", "arg2": "6"} }
			--
			-- argument 1 is file_name
			-- argument 2 is measuring_point_id
			-- Works with item and last_item_id	
		local
			l_mu_name: STRING
		do
			l_mu_name := default_name
			if current_row_index < start_row_index then
				set_csv_header (a_csv_row)
			else
				if not csv_header_is_valid then
					logger.write_error ("Csv header is not valid")
					check
						csv_header_is_valid: False
					end
				else
					if attached {ENUMERATE_DB_SERVICE} {SIT_ENVIRONMENT}.app_instance.db_service_from_entity_type ({detachable ENUMERATE}) as l_enum_dbs then
						if attached db_service.item as l_item and then
							attached csv_header as l_csv_header and then
							attached date_time_format as l_dt_format
						then -- covered by require
							measuring_point.extend_measure_unit (create {CURRENT_UNIT}.make_from_csv_line (a_csv_row, l_csv_header, current_row_index, l_dt_format, "Timestamp", "I1", l_item, l_mu_name, l_enum_dbs.enumerate_cash_from_name ({DB_CONSTANTS}.Enumerate_line1), Void))
							measuring_point.extend_measure_unit (create {CURRENT_UNIT}.make_from_csv_line (a_csv_row, l_csv_header, current_row_index, l_dt_format, "Timestamp", "I2", l_item, l_mu_name, l_enum_dbs.enumerate_cash_from_name ({DB_CONSTANTS}.Enumerate_line2), Void))
							measuring_point.extend_measure_unit (create {CURRENT_UNIT}.make_from_csv_line (a_csv_row, l_csv_header, current_row_index, l_dt_format, "Timestamp", "I3", l_item, l_mu_name, l_enum_dbs.enumerate_cash_from_name ({DB_CONSTANTS}.Enumerate_line3), Void))
							measuring_point.extend_measure_unit (create {CURRENT_UNIT}.make_from_csv_line (a_csv_row, l_csv_header, current_row_index, l_dt_format, "Timestamp", "In", l_item, l_mu_name, l_enum_dbs.enumerate_cash_from_name ({DB_CONSTANTS}.Enumerate_neutral), Void))

							measuring_point.extend_measure_unit (create {CHARGE_UNIT}.make_from_csv_line (a_csv_row, l_csv_header, current_row_index, l_dt_format, "Timestamp", "P1", l_item, l_mu_name, l_enum_dbs.enumerate_cash_from_name ({DB_CONSTANTS}.Enumerate_line1), agent (a_val: STRING): like {CHARGE_UNIT}.value do create Result.make_from_kw_string (a_val) end))
							measuring_point.extend_measure_unit (create {CHARGE_UNIT}.make_from_csv_line (a_csv_row, l_csv_header, current_row_index, l_dt_format, "Timestamp", "P2", l_item, l_mu_name, l_enum_dbs.enumerate_cash_from_name ({DB_CONSTANTS}.Enumerate_line2), agent (a_val: STRING): like {CHARGE_UNIT}.value do create Result.make_from_kw_string (a_val) end))
							measuring_point.extend_measure_unit (create {CHARGE_UNIT}.make_from_csv_line (a_csv_row, l_csv_header, current_row_index, l_dt_format, "Timestamp", "P3", l_item, l_mu_name, l_enum_dbs.enumerate_cash_from_name ({DB_CONSTANTS}.Enumerate_line3), agent (a_val: STRING): like {CHARGE_UNIT}.value do create Result.make_from_kw_string (a_val) end))
							measuring_point.extend_measure_unit (create {CHARGE_UNIT}.make_from_csv_line (a_csv_row, l_csv_header, current_row_index, l_dt_format, "Timestamp", "P", l_item, l_mu_name, l_enum_dbs.enumerate_cash_from_name ({DB_CONSTANTS}.Enumerate_neutral), agent (a_val: STRING): like {CHARGE_UNIT}.value do create Result.make_from_kw_string (a_val) end))

							measuring_point.extend_measure_unit (create {TENSION_UNIT}.make_from_csv_line (a_csv_row, l_csv_header, current_row_index, l_dt_format, "Timestamp", "V1", l_item, l_mu_name, l_enum_dbs.enumerate_cash_from_name ({DB_CONSTANTS}.Enumerate_line1), Void))
							measuring_point.extend_measure_unit (create {TENSION_UNIT}.make_from_csv_line (a_csv_row, l_csv_header, current_row_index, l_dt_format, "Timestamp", "V2", l_item, l_mu_name, l_enum_dbs.enumerate_cash_from_name ({DB_CONSTANTS}.Enumerate_line2), Void))
							measuring_point.extend_measure_unit (create {TENSION_UNIT}.make_from_csv_line (a_csv_row, l_csv_header, current_row_index, l_dt_format, "Timestamp", "V3", l_item, l_mu_name, l_enum_dbs.enumerate_cash_from_name ({DB_CONSTANTS}.Enumerate_line3), Void))
						end
					else
						check
							enumerate_db_service_not_found: False
						end
					end

				end
			end
			current_row_index := current_row_index + 1
		end
end
