note
	description: "Summary description for {MEASURING_POINT_CSV}."
	author: ""
	date: "$Date$"
	revision: "$Revision$"

deferred class
	MEASURING_POINT_CSV

inherit
	SIT_CSV[MEASURING_POINT_DB_SERVICE]
		redefine
			make
		end

feature {NONE} -- Initialization

	make (a_rest_request: like rest_request; a_db_service: like db_service)
			-- taking measuring_point_id from REST_REQUEST
			-- Setting date_format with Default_date_format
		require else
			a_rest_request.has_request_feature
			valid_arguments: attached a_rest_request.request_feature as l_req_f and then
				l_req_f.has_arguments and then
				l_req_f.arguments.count = 2
			first_argument_is_file_name: attached l_req_f.arguments.at(1) as l_arg1 and then
				not l_arg1.is_empty
			second_argument_is_integer: attached l_req_f.arguments.at(2) as l_arg2 and then
				l_arg2.is_integer and then
				l_arg2.to_integer > 0
		do
			Precursor (a_rest_request, a_db_service)
			date_time_format := Default_date_time_format

			if attached a_rest_request.request_feature as l_req_f and then
				attached l_req_f.arguments.at(1) as l_file_path and then
				attached l_req_f.arguments.at(2) as l_measuring_point_id_s and then
				l_measuring_point_id_s.is_integer_64
			then
				db_service.load_from_primary_key (l_measuring_point_id_s.to_integer_64)
				if attached db_service.item as l_mp then
					measuring_point := l_mp
				else
					create measuring_point.make (0)-- void safety
					set_last_error (create {PARSE_ERROR}.make ("make-> measuring_point with id:" + l_measuring_point_id_s + " not found"))
					check
						should_not_happen: False
					end
				end

				file_path := l_file_path
			else
				create measuring_point.make (0)-- void safety
				check
					should_not_happen: False
				end
			end
		ensure then
			attached file_path
			measuring_point.primary_key > 0
			attached date_time_format as l_dtf and then l_dtf = Default_date_time_format
		end

feature -- Status report

	default_name: STRING
		do
			Result := "imported:" + (create {DATE_TIME}.make_now_utc).formatted_out ("yyyy-mm-ddT[0]hh:[0]mi:[0]ssZ") + " measuring_point_id:" + measuring_point.primary_key.out + " line:" + current_row_index.out
			if attached file_path as l_fp then
				Result.append (" fp: " + l_fp)
			end
		end

feature -- Access

	Default_date_time_format: like date_time_format = "yyyy-mm-ddThh:mi:ssZ"

	measuring_point: MEASURING_POINT

end
