note
	description: "Summary description for {SIT_CSV_HANDLER}."
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	SIT_CSV_HANDLER

inherit
	UT_CSV_HANDLER
		redefine
			read_file
		end

create

	make,
	make_with_separator

feature -- Input

	read_file (a_file: KI_TEXT_INPUT_STREAM; a_action: PROCEDURE [DS_ARRAYED_LIST [STRING]])
			-- Read csv file `a_file' and for each row, call `a_action' where the list
			-- passed as argument is the list of cells making up this row (using
			-- `separator' as separator). The list passed as argument is supposed to
			-- be non-void and contains no void strings. This list object is reused
			-- (and hence altered) between each call. The cell strings it contains
			-- are not altered and can be kept without the need to clone them.
		local
			i, nb: INTEGER
			l_last_string: STRING
			l_cell: STRING
			c: CHARACTER
			has_quote: BOOLEAN
			l_cells: DS_ARRAYED_LIST [STRING]
			l_forth_done: BOOLEAN
		do
			if not a_file.end_of_input then
				create l_cells.make (512)
				create l_cell.make (100)
				from
					a_file.read_string (1024)
				until
					a_file.end_of_input
				loop
					l_forth_done := False
					l_last_string := a_file.last_string
					nb := l_last_string.count
					from i := 1 until i > nb loop -- Loops into string of 1024 B
						l_forth_done := False
						c := l_last_string.item (i)
						if c = '%"' then
							if has_quote then
								i := i + 1
								if i > nb then
									a_file.read_string (1024)
									if not a_file.end_of_input then
										l_last_string := a_file.last_string
										i := 1
										nb := l_last_string.count
									end
								end
								if i <= nb and then l_last_string.item (i) = '%"' then
									l_cell.append_character ('%"')
								else
									l_forth_done := True
									has_quote := False
								end
							elseif l_cell.is_empty then
								has_quote := True
							else
								l_cell.append_character ('%"')
							end
						elseif c = separator then
							if has_quote then
								l_cell.append_character (c)
							else
								l_cells.force_last (l_cell.substring (1, l_cell.count))
								STRING_.wipe_out (l_cell)
							end
						elseif c = '%N' then
							if has_quote then
--								l_cell.append_character (c)
							else
								l_cells.force_last (l_cell.substring (1, l_cell.count - 1))
								STRING_.wipe_out (l_cell)
								a_action.call ([l_cells])
								l_cells.wipe_out
							end
						else
							l_cell.append_character (c)
						end
						if not l_forth_done then
							i := i + 1
						end
					end
					if not l_forth_done then
						a_file.read_string (1024)
					end
				end
				if not l_cell.is_empty then
					l_cells.force_last (l_cell.substring (1, l_cell.count))
				end
				if not l_cells.is_empty then
					a_action.call ([l_cells])
				end
			end
		end

end
