note
	description: "Summary description for {DATE_CONSTRAINT}."
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	DATE_CONSTRAINT

inherit
	FIELD_CONSTRAINT
		rename
			value as start_date_time
		export
			{NONE} make
		redefine
			start_date_time,
			to_sql
		end

create
	make_from_interval

feature {NONE} -- Initialize

	make_from_interval (a_table_name: like table_name; a_start_date_time, an_end_date_time: like start_date_time; a_field: like field)
		do
			end_date_time := an_end_date_time
			make (a_table_name, a_field, Between_operator, a_start_date_time)
		ensure
			field = a_field
			start_date_time = a_start_date_time
			end_date_time = an_end_date_time
		end

feature -- Access

	start_date_time: DATE_TIME

	end_date_time: like start_date_time

feature -- Status setting

	set_start_date_time (v: like start_date_time)
		do
			start_date_time := v
		ensure
			start_date_time = v
		end

feature -- Out

	to_sql: STRING
		do
			Result := table_dot_field + operator + {SQL_UTIL}.from_value_to_db_field_string (start_date_time, False) + And_statement + {SQL_UTIL}.from_value_to_db_field_string (end_date_time, False)
		end

invariant
	start_date_time <= end_date_time
	operator = Between_operator
end
