note
	description: "Summary description for {FIELD_CONSTRAINT}."
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	FIELD_CONSTRAINT

inherit
	CONSTRAINT

create
	make

feature {NONE} -- Initialization

	make (a_table_name: like table_name; a_field: like field; an_operator: like operator; v: like value)
		require
			valid_operator (an_operator)
		do
			table_name := a_table_name
			field := a_field
			value := v
			default_create
			operator := an_operator
		ensure
			table_name = a_table_name
			field = a_field
			operator = an_operator
			value = v
		end

feature -- Access

	table_name: detachable STRING

	field: STRING

	value: ANY

feature -- Status report

	table_dot_field: like field
		do
			if attached table_name as l_t and then
				not l_t.is_empty
			then
				Result := l_t + "." + field
			else
				Result := field.twin
			end
		end

feature -- Out

	to_sql: STRING
		do
			Result := table_dot_field
			Result.append (operator)
			Result.append ({SQL_UTIL}.from_value_to_db_field_string (value, False))
		end


invariant
	not field.is_empty
end
