note
	description: "Summary description for {JOIN}."
	author: ""
	date: "$Date$"
	revision: "$Revision$"

deferred class
	JOIN

inherit
	ANY
		redefine
			default_create
		end

feature {NONE} -- Initialization

	default_create
		do
			table_name_to_join := ""
			table_alias := ""
			table_name := ""
			table_column := ""
			target_table_name := ""
			target_column := ""
		end

	make_from_fields (
		a_table_name_to_join : like table_name_to_join;
		a_join_table_alias: detachable like table_alias;
		a_join_table_name,
		a_join_table_column,
		a_join_target_table_name,
		l_join_target_column: STRING)
		do
			table_name_to_join := a_table_name_to_join
			table_alias := a_join_table_alias
			table_name := a_join_table_name
			table_column := a_join_table_column
			target_table_name := a_join_target_table_name
			target_column := l_join_target_column
		ensure
			table_name_to_join = a_table_name_to_join
			table_alias = a_join_table_alias
			table_name = a_join_table_name
			table_column = a_join_table_column
			target_table_name = a_join_target_table_name
			target_column = l_join_target_column
		end

feature -- Access

	table_name_to_join: STRING
	table_alias: detachable STRING
	table_name: STRING
	table_column: STRING
	target_table_name: STRING
	target_column: STRING

	predicate: STRING
		deferred
		end

feature -- Out


	to_sql: STRING
		do
			Result := predicate
			Result.append (table_name_to_join)
	        if attached table_alias as l_table_alias then
	        	Result.append (" " + l_table_alias)
	        end
	        Result.append (" ON " +
									 	table_name + "." + table_column + " = " +
									 	target_table_name + "." + target_column
	        )
		end

invariant
	not predicate.is_empty
end
