note
	description: "Summary description for {ORDER_CLAUSE}."
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	ORDER_CLAUSE

create
	make

feature {NONE} -- Initialization

	make ( a_table_name: like table_name; a_field: like field; a_way: like way)
		do
			table_name := a_table_name
			field := a_field
			way := a_way
			default_create
		ensure
			way = a_way
			table_name = a_table_name
			field = a_field
		end

feature -- Access

	Way_ascending: STRING = " ASC"
	Way_descending: STRING = " DESC"

	table_name: detachable STRING

	field: ANY

	way: STRING

feature -- Validation

	valid_way (a_way: like way): BOOLEAN
		do
			Result := a_way = Way_ascending or
				a_way = Way_descending
		end

feature -- Out

	to_sql: STRING
		do
			Result := ""
			if attached table_name as l_table then
				Result.append (l_table + ".")
			end
			Result.append (field.out)
			Result.append (way)
		end

invariant
	valid_way (way)
end
