note
	description: "Summary description for {SQL_QUERY}."
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	SQL_QUERY

inherit
	SQL_STATEMENT
		redefine
			make,
			default_create
		end

	CONSTRAINED
		rename
			to_sql as constraints_to_sql
		redefine
			default_create
		end

create
	make,
	make_with_constraint

feature -- Initialization

	default_create
		do
			create order_clauses.make
			Precursor {CONSTRAINED}
			Precursor {SQL_STATEMENT}
		end

	make (a_base_entity: like base_entity)
		do
			Precursor (a_base_entity)
			--limit := 100
		end

	make_with_constraint (a_base_entity: like base_entity; a_constraint: CONSTRAINT)
		do
			make (a_base_entity)
			add_constraint (a_constraint)
		ensure
			constraints.has (a_constraint)
		end

feature -- Access

	limit: INTEGER

	order_clauses: LINKED_LIST[ORDER_CLAUSE]

feature -- Status setting

	set_limit (v: like limit)
		do
			limit := v
		ensure
			limit = v
		end

	add_constraint (a_constraint: like constraints.item)
		do
			constraints.extend (a_constraint)
		ensure
			constraints.has (a_constraint)
		end

feature -- Status report



feature -- Output

	to_sql: STRING
		do
			Result := "SELECT * "
			Result.append ("%NFROM ONLY " + base_entity.table_name)
			Result.append (constraints_to_sql)
			Result.append (limit_to_sql)
		end

	limit_to_sql: STRING
		do
			Result := ""
			if limit > 0 then
				Result.append ("%NLIMIT " + limit.out)
			end
		end

end
