note
	description: "Summary description for {SQL_UTIL}."
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	SQL_UTIL

feature -- Datetime conversions

	Sql_date_time_format: STRING = "YYYY-MM-DD [0]hh:[0]mi:[0]ss"



	from_value_to_db_field_string (a_value: ANY; a_return_default: BOOLEAN ): STRING
			-- Generally from Eiffel to Database
		do
			if a_return_default then
				Result := "DEFAULT"
			else
				if attached {INTEGER_64} a_value as l_int then
					Result := l_int.out
				elseif attached {INTEGER_32} a_value as l_int then
					Result := l_int.out
				elseif attached {REAL_32} a_value as l_real then
					Result := l_real.out
				elseif attached {REAL_64} a_value as l_real then
					Result := l_real.out
				elseif attached {WATT} a_value as l then
					Result := l.out
				elseif attached {K_WATT_H} a_value as l then
					Result := l.out
				elseif attached {VOLT} a_value as l then
					Result := l.out
				elseif attached {AMPERE} a_value as l then
					Result := l.out
				elseif attached {DATE} a_value as l then
					Result := "'" + l.formatted_out ({APP_CONFIGURATION}.Date_default_format_string) + "'"
				elseif attached {DATE_TIME} a_value as l then
					Result := "'" + l.formatted_out ({APP_CONFIGURATION}.Date_time_default_format_string) + "'"
				elseif attached {STRING_8} a_value as l_value_s then
					Result := "'" + l_value_s + "'" -- TODO: LOW escape characters like '"' here!
				elseif attached {STRING_32} a_value as l_value_s then
					Result := "'" + l_value_s + "'" -- TODO: LOW escape characters like '"' here!
				elseif attached {NATURAL_64} a_value as l_v then
					Result := l_v.out -- TODO: LOW escape characters like '"' here!
				else
					check
						unimplemented_type_conversion: False
					end
					Result := a_value.out
				end
			end
		ensure
			instance_free: class
		end


end
