note
	description: "Summary description for {BRANCH}."
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	BRANCH

inherit
	RELATED_PK_DB_ENTITY
		redefine
			default_create,
			fields_mapping,
			valid_for_insert
		end

	API_EXPORTABLE_ENTITY
		undefine
			out
		redefine
			default_create
		end

create
	default_create,
	make,
	make_from_json,
	make_from_json_object,
	make_from_db_service


feature {NONE} -- Initialization

	default_create
		do
			name := ""
			Precursor {API_EXPORTABLE_ENTITY}
			Precursor {RELATED_PK_DB_ENTITY}
		end

	add_exported_fields
		do
			api_exported_fields.extend (Primary_key_db_column_name)
			api_exported_fields.extend (Name_db_column_name)
			api_exported_fields.extend (Discount_factor_db_column_name)
		end

feature -- Status report

	valid_for_insert: BOOLEAN
		-- Is Current object valid to be inserted into DB
		-- Redefine me if you need more business
		do
			Result := Precursor and name.count > 0
			if Result then
				across
					relationships as l_relationship
				until
					not Result
				loop
					if attached {like company_relationship} l_relationship.item as l_m_t_o then
						Result := attached l_m_t_o.secondary as l_sec
							and then l_sec.primary_key > 0
					end
				end
			end
		end

feature -- DB Field names

	Name_db_column_name: STRING = "name"
	Discount_factor_db_column_name: STRING = "discount_factor"

	fields_mapping: like {DB_ENTITY}.fields_mapping
		do
			Result := Precursor
			Result.extend (create {DB_FIELD}.make (Name_db_column_name, agent set_name (?), name, {like name}))
			Result.extend (create {DB_FIELD}.make (Discount_factor_db_column_name, agent set_discount_factor (?), discount_factor, {like discount_factor}))
		end

feature -- Access

	name: STRING
	discount_factor: REAL

	company_relationship: MANY_TO_ONE[like Current, COMPANY]
		attribute
			create Result.make(Current, True)
		end

	consumption_sectors_relationship: ONE_TO_MANY[like Current, CONSUMPTION_SECTOR]
		attribute
			create Result.make(Current, False)
		end


feature -- Status setting

	set_name (v: like name)
		do
			name := v
		ensure
			name = v
		end

	set_discount_factor (v: like discount_factor)
		do
			discount_factor := v
		ensure
			discount_factor = v
		end

	set_relationships
		do
			add_relationship (company_relationship)
			add_relationship (consumption_sectors_relationship)
		end

end
