note
	description: "Summary description for {CHARGE_TEMPLATE}."
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	CHARGE_TEMPLATE
inherit
	RELATED_PK_DB_ENTITY
		redefine
			default_create,
			fields_mapping
		end

	API_EXPORTABLE_ENTITY
		undefine
			out
		redefine
			default_create
		end

create
	default_create,
	make,
	make_from_json,
	make_from_json_object,
	make_from_db_service


feature {NONE} -- Initialization

	default_create
		do
			name := ""
			create charge_max
			Precursor {API_EXPORTABLE_ENTITY}
			Precursor {RELATED_PK_DB_ENTITY}

--			db_unstored_field_names.extend (Category_id_join_column_name)

			invalid_field_names_for_setter.prune_all (Charge_max_db_column_name)
		end

	add_exported_fields
		do
			api_exported_fields.extend (Primary_key_db_column_name)
			api_exported_fields.extend (Name_db_column_name)
			api_exported_fields.extend (Charge_max_db_column_name)
		end

feature -- DB Field names

	Name_db_column_name: STRING = "name"
	Charge_max_db_column_name: STRING = "charge_max"

	Api_exportable_db_column_name: STRING = "charge_template" -- same as table_name

	fields_mapping: LINKED_SET[DB_FIELD]
		do
			Result := Precursor
			Result.extend (create {DB_FIELD}.make (Name_db_column_name, agent set_name (?), name, {like name}))
			Result.extend (create {DB_FIELD}.make (Charge_max_db_column_name, agent set_charge_max (?), charge_max, {like charge_max})) -- if has an '_' prune it from invalid_field_names_for_setter
		end

feature -- Access

	name: STRING

	charge_max: WATT

	charge_unit_relationship: ONE_TO_MANY_JOIN[like Current, CHARGE_UNIT]
		attribute
			create Result.make(Current, False)
		end

feature -- Status report

	has_charge_units: BOOLEAN
		do
			Result := not charge_unit_relationship.secondaries.is_empty
		end

feature -- Status setting

	set_name (v: like name)
		do
			name := v
		ensure
			name = v
		end

	set_charge_max (v: like charge_max)
		do
			charge_max := v
		ensure
			charge_max = v
		end


	set_relationships
		do
			add_relationship (charge_unit_relationship)
		end

end
