note
	description: "Summary description for {CONSUMPTION_SECTOR}."
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	CONSUMPTION_SECTOR


inherit
	RELATED_PK_DB_ENTITY
		redefine
			default_create,
			fields_mapping
		end

	API_EXPORTABLE_ENTITY
		undefine
			out
		redefine
			default_create
		end

create
	default_create,
	make,
	make_from_json,
	make_from_json_object,
	make_from_db_service


feature {NONE} -- Initialization

	default_create
		do
			name := ""
			Precursor {API_EXPORTABLE_ENTITY}
			Precursor {RELATED_PK_DB_ENTITY}
		end

	add_exported_fields
		do
			api_exported_fields.extend (Primary_key_db_column_name)
			api_exported_fields.extend (Name_db_column_name)
		end

feature -- DB Field names

	Name_db_column_name: STRING = "name"

	fields_mapping: like {DB_ENTITY}.fields_mapping
		do
			Result := Precursor
			Result.extend (create {DB_FIELD}.make (Name_db_column_name, agent set_name (?), name, {like name}))
		end

feature -- Access

	name: STRING

	branch_relationship: MANY_TO_ONE[like Current, BRANCH]
		attribute
			create Result.make(Current, True)
		end

	measuring_point_relationship: ONE_TO_MANY[like Current, MEASURING_POINT]
		attribute
			create Result.make(Current, False)
		end


feature -- Status setting

	set_name (v: STRING)
		do
			name := v
		ensure
			name = v
		end

	set_relationships
		do
			add_relationship (branch_relationship)
			add_relationship (measuring_point_relationship)
		end

end
