note
	description: "Summary description for {ELECTRICITY_INVOICE}."
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	ELECTRICITY_INVOICE

inherit
	INVOICE
		undefine
			make_from_db_service,
			valid_for_insert,
			valid_for_update,
			valid_for_delete,
			to_json,
			set_from_json,
			sequence_name
		redefine
			default_create,
			set_from_db_service,
			fields_mapping
		select
			fields_mapping
		end

	RELATED_PK_DB_ENTITY
		rename
			fields_mapping as fields_mapping_dbe
		redefine
			default_create,
			set_from_db_service,
			sequence_name
		end

create
	default_create,
	make_from_json,
	make_from_json_object,
	make_from_db_service

feature {NONE} -- Initialization

	default_create
		do
			create date.make_now_utc -- because related_db_entity calls fields_mapping from invoice...
			Precursor {RELATED_PK_DB_ENTITY}
			Precursor {INVOICE}
		end

feature -- DB Field names

	Electricity_amount_column_name: STRING = "electricity_amount"

	fields_mapping: like {DB_ENTITY}.fields_mapping
		do
			Result := Precursor {INVOICE}
			Result.extend (create {DB_FIELD}.make (Electricity_amount_column_name, agent set_electricity_amount (?), electricity_amount, {like electricity_amount}))
		end

feature -- Access

	sequence_name: STRING
		do
			Result := "invoice"
		end

	electricity_amount: NATURAL_64

	consumption_sector_relationship: ONE_TO_ONE[like Current, CONSUMPTION_SECTOR]
		attribute
			create Result.make (Current, False)
		end

	electricity_rate_relationship: ONE_TO_ONE[like Current, ELECTRICITY_RATE]
		attribute
			create Result.make (Current, False)
		end

feature -- Status setting

	set_from_db_service (a_db_service: DB_SERVICE[like Current])
		do
			Precursor {RELATED_PK_DB_ENTITY} (a_db_service)
			Precursor {INVOICE} (a_db_service)
		end


	set_electricity_amount (v: like electricity_amount)
		do
			electricity_amount := v
		ensure
			electricity_amount = v
		end

feature -- Relationships

	set_relationships
			-- from deferred RELATED_DB_ENTITY called by default_create
		do
			add_relationship (consumption_sector_relationship)
			add_relationship (electricity_rate_relationship)

--			add_relationship (distribution_company_relationship)
		end

end
