note
	description: "Summary description for {INVOICE}."
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	INVOICE

inherit
	PK_DB_ENTITY
		redefine
			default_create,
			fields_mapping
		end

create
	default_create,
	make_from_json,
	make_from_json_object,
	make_from_db_service

feature {NONE} -- Initialization

	default_create
		do
			create date.make_now_utc
			Precursor
		end

feature -- DB Field names

	Date_column_name: STRING = "a_date"
	Amount_db_column_name: STRING = "amount"

	fields_mapping: LINKED_SET[DB_FIELD]
		do
			Result := Precursor
			Result.extend (create {DB_FIELD}.make (Date_column_name, agent set_date (?), date, {like date}))
			Result.extend (create {DB_FIELD}.make (Amount_db_column_name, agent set_amount (?), amount, {like amount}))
		end

feature -- Access

	date: DATE
	amount: NATURAL_64

feature -- Status setting

	set_date (v: like date)
		do
			date := v
		ensure
			date = v
		end

	set_amount (v: like amount)
		do
			amount := v
		ensure
			amount = v
		end

invariant
	amount >= 0

end
