note
	description: "Summary description for {TENSION_UNIT}."
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	TENSION_UNIT


inherit
	MEASURE_UNIT
		redefine
			default_create,
			value
		end

create
	default_create,
	make_from_date_time,
	make_from_json,
	make_from_json_object,
	make_from_db_service,
	make_from_csv_line

feature {NONE} -- Initialize

	default_create
		do
			create value
			Precursor
		end

	make_from_csv_line(
			a_csv_line,
			a_csv_header: DS_ARRAYED_LIST[STRING];
			a_csv_line_index: INTEGER;
			a_dt_format,
			a_csv_header_date_time_key,
			a_csv_header_value_key: STRING;
			a_measuring_point: attached like measuring_point_relationship.secondary;
			a_name: STRING;
			an_index: attached like an_index_relationship.secondary;
			a_transformation_function: detachable FUNCTION[STRING, like value];
			)
		do
			default_create
			impl_set_date_time (a_csv_line, a_csv_header, a_csv_header_date_time_key, a_csv_line_index, a_dt_format)
			-- Value
			if attached col_from_csv_line (a_csv_line, a_csv_header, a_csv_header_value_key) as l_csv_data then
				if attached a_transformation_function then
					set_value (a_transformation_function.item (l_csv_data))
				elseif l_csv_data.is_real or else l_csv_data.is_integer then
					set_value (l_csv_data.to_real)
				else
					logger.write_warning ("Error in line " + a_csv_line_index.out + " value is not real or integer:" + l_csv_data)
					is_valid := False
				end
			else
				logger.write_warning ("make_from_csv_line->Unable to find key into header:" + a_csv_header_date_time_key)
				is_valid := False
			end

			if is_valid then
				measuring_point_relationship.set_secondary (a_measuring_point)
				an_index_relationship.set_secondary (an_index)
				name := a_name
			end
		end

feature -- Access

	value: VOLT

end
