note
	description: "Summary description for {DB_REQUEST}."
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	DB_REQUEST


inherit
	LOGGABLE
		redefine
			default_create
		end

	CONSTRAINED
		undefine
			out
		redefine
			default_create
		end


feature {NONE} -- Initialize

	default_create
		do
			create order_clauses.make
			Precursor {LOGGABLE}
			Precursor {CONSTRAINED}
		end

feature -- Access

	relationships: detachable like {RELATED_DB_ENTITY}.relationships -- relationships for constraints

	order_clauses: LINKED_SET[ORDER_CLAUSE]

feature -- Status report

	has_relationships: BOOLEAN
		do
			Result := attached relationships
		end

feature -- Element change

	add_relationship_loadable_from_resultset (a_relationship: RELATIONSHIP[RELATED_DB_ENTITY, DB_ENTITY])
			-- clones given relationship before adding it and sets it to loadable_from_resultset
		local
			l_rel: like a_relationship
		do
			l_rel := a_relationship.deep_twin
			l_rel.set_loadable_from_resultset (True)
			add_relationship (l_rel)
		end

	add_relationship_loadable_from_secondary_type (a_primary_db_entity: RELATED_DB_ENTITY; a_secondary_type: like relationships.item.secondary_type)
			-- clones given relationship before adding it and sets it to loadable_from_resultset
		local
			l_rel_tmp: like {RELATED_DB_ENTITY}.relationships.item
			l_type_s: STRING
		do
			if attached a_primary_db_entity.relationship_from_secondary_type_equal (a_secondary_type) as l_rel then
				l_rel_tmp := l_rel.deep_twin
				l_rel_tmp.set_loadable_from_resultset (True)
				add_relationship (l_rel_tmp)
			else
				if attached a_secondary_type as l_type then
					l_type_s := a_secondary_type.generating_type.out
				else
					l_type_s := "Void"
				end
				logger.write_error ("add_relationship_loadable_from_secondary_type->Secondary " + l_type_s + " not found into relationships")
				check
					relationship_secondary_not_found: False
				end
			end
		end

	add_relationship_from_secondary_type (a_primary_db_entity: RELATED_DB_ENTITY; a_secondary_type: like relationships.item.secondary_type)
			-- clones given relationship before adding it
		local
			l_rel_tmp: like {RELATED_DB_ENTITY}.relationships.item
			l_type_s: STRING
		do
			if attached a_primary_db_entity.relationship_from_secondary_type_equal (a_secondary_type) as l_rel then
				l_rel_tmp := l_rel.deep_twin
				add_relationship (l_rel_tmp)
			else
				if attached a_secondary_type as l_type then
					l_type_s := a_secondary_type.generating_type.out
				else
					l_type_s := "Void"
				end
				{SIT_UTIL}.raise_exception ("add_relationship_from_secondary_type->Secondary " + l_type_s + " not found into relationships")
				check
					relationship_secondary_not_found: False
				end
			end
		end


	add_relationship (a_relationship: RELATIONSHIP[RELATED_DB_ENTITY, DB_ENTITY])
--		require -- removed because of MEASURE_UNIT_DB_SERVICE.items_from_date_time_interval doesn't need the relationship to be loaded but for constraint to be applied
--			a_relationship.loadable_from_resultset -- dont forget to do it before, otherwise you wont get it into results, set it into db_service.item_prototype
		require
			attached relationships as l_rel implies not l_rel.has (a_relationship)
		do
			if not attached relationships then
				create relationships.make
			end
			if attached relationships as l_rel then
				l_rel.extend (a_relationship)
			end
		ensure
			attached relationships as l_rel
--			attached relationships_from_data as l_rel and then
--			attached old relationships_from_data as l_rel_old and then
--				l_rel.count = l_rel_old.count + 1
		end




end
