note
	description: "Summary description for {SIT_ENVIRONENT}."
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	SIT_ENVIRONMENT

inherit
	LOGGABLE
		redefine
			default_create
		end

create
	default_create

feature -- Initialize

	default_create
		do
			Precursor
		end

feature -- Access

	handlers: LINKED_LIST[SIT_HANDLER[DB_ENTITY]]
		once
			create Result.make
		end

	db_services: LINKED_LIST[DB_SERVICE[DB_ENTITY]]
		once
			create Result.make
		end

	app_instance: SIT_ENVIRONMENT
		once
			create Result
		ensure
			instance_free: class
		end

feature -- Status setting

	add_handler (a_handler: like handlers.item)
		do
			handlers.extend (a_handler)
		ensure
			handlers.last = a_handler
		end

	add_db_service (a_db_service: like db_services.item)
		do
			db_services.extend (a_db_service)
		ensure
			db_services.last = a_db_service
		end

feature -- Status report

	handled_entity_item_prototype (a_class_name: STRING): detachable like handlers.item.item_prototype
			-- if found with class_name lowercase
		do
			across
				handlers as l_handler
			loop
				if {SIT_UTIL}.class_name_lowercase (l_handler.item.item_prototype.generating_type.out).is_equal (a_class_name) then
					Result := l_handler.item.item_prototype
				end
			end
		end

	db_service_from_entity_type (an_entity_type: TYPE[detachable DB_ENTITY]): detachable like db_services.item
			-- call with {detachable COMPANY} for ex as argument or obj.generating_type
			-- @see https://stackoverflow.com/questions/55533727/eiffel-type-conformance-how-to-give-a-type-instead-of-an-instance
		local
			l_generating_type: like db_services.item.item_prototype.generating_type
		do
			across
				db_services as l_dbs
			until
				Result /= Void
			loop
				l_generating_type := l_dbs.item.item_prototype.generating_type
				if l_dbs.item.item_prototype.generating_type.conforms_to (an_entity_type) then
					Result := l_dbs.item
				end
			end
			if not attached Result then
				logger.write_error ("Service " + an_entity_type.generating_type.out + " NOT FOUND!")
			end
		ensure
			service_found: attached Result
		end

end
