note
	description: "Summary description for {SIT_CONVERTER}."
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	SIT_TYPE_CONVERTER

feature -- TYPES Operations

	force_as_integer_32 (an_any: ANY): INTEGER_32
		do
			if attached {INTEGER} an_any as l_int then
				Result := l_int.as_integer_32
			elseif attached {INTEGER_32_REF} an_any as l_int then
				Result := l_int.as_integer_32
			elseif attached {INTEGER_64_REF} an_any as l_int then
				Result := l_int.as_integer_32
			elseif attached {JSON_NUMBER} an_any as l_i then
				Result := l_i.integer_64_item.as_integer_32
			elseif attached {JSON_STRING} an_any as l_s then
				Result := l_s.unescaped_string_8.to_integer_32
			else
				check
					couldnt_transform_type_to_result: False
				end
			end
		ensure
			instance_free: class
		end

	force_as_integer_64 (an_any: ANY): INTEGER_64
		do
			if attached {INTEGER} an_any as l_int then
				Result := l_int.as_integer_64
			elseif attached {INTEGER_32_REF} an_any as l_int then
				Result := l_int.as_integer_64
			elseif attached {INTEGER_64_REF} an_any as l_int then
				Result := l_int.as_integer_64
			elseif attached {JSON_NUMBER} an_any as l_i then
				Result := l_i.integer_64_item
			elseif attached {JSON_STRING} an_any as l_s then
				Result := l_s.unescaped_string_8.to_integer_64
			elseif attached {STRING_8} an_any as l_s then
				Result := l_s.to_integer_64
			else
				check
					couldnt_transform_type_to_result: False
				end
			end
		ensure
			instance_free: class
		end

	force_as_natural_64 (an_any: ANY): NATURAL_64
		do
			if attached {INTEGER_32_REF} an_any as l_int then
				if l_int.out.is_natural_64 then
					Result := l_int.out.to_natural_64
				else
--					io.put_string("%N ERROR: force_as_natural_64:" + an_any.out + " res:" + Result.out + "-------------------------------returning 0 waiting for fix") -- https://stackoverflow.com/questions/54463744/eiffel-odbc-dealing-with-bigint
					check
						not_happening: True
					end
				end
				io.put_string("%Nforce_as_natural_64:" + an_any.out + " res:" + Result.out)
			elseif attached {INTEGER_64_REF} an_any as l_int then
				if l_int.out.is_natural_64 then
					Result := l_int.to_natural_64
				else
--					io.put_string("%N ERROR: force_as_natural_64:" + an_any.out + " res:" + Result.out + "-------------------------------returning 0 waiting for fix") -- https://stackoverflow.com/questions/54463744/eiffel-odbc-dealing-with-bigint
					check
						not_happening: True
					end
				end
--				io.put_string("%Nforce_as_natural_64:" + an_any.out + " res:" + Result.out)
			elseif attached {JSON_NUMBER} an_any as l_v then
				if l_v.is_integer then
					Result := l_v.integer_64_item.to_natural_64
				else
					check
						not_implemented: False
					end
				end
			else
				check
					not_implemented_case: False
				end
			end
		ensure
			instance_free: class
		end

	force_as_string (an_any: ANY): STRING
			-- From JSON and Eiffel
		do
			Result := "ErrorIn:force_to_string of SIT_CONVERTER"
			if attached {DATE_TIME} an_any as l_dt then
				Result := ""
			elseif attached {JSON_STRING} an_any as l_s then
				Result := l_s.unescaped_string_8
			elseif attached {STRING_8} an_any as l_s then
				Result := l_s.out
			elseif attached {STRING_32} an_any as l_s then
				Result := l_s.as_string_8
			elseif attached {INTEGER_32_REF} an_any as l_i then
				Result := l_i.out
			else
				check
					couldnt_transform_type_to_result: False
				end
			end
		ensure
			instance_free: class
		end

	force_as_watt (an_any: ANY): WATT
		do
			create Result.make_from_integer_64 (force_as_integer_64 (an_any))
		ensure
			instance_free: class
		end

	force_as_volt (an_any: ANY): VOLT
		do
			create Result.make_from_real (force_as_real (an_any))
		ensure
			instance_free: class
		end

	force_as_ampere (an_any: ANY): AMPERE
		do
			create Result.make_from_real (force_as_real (an_any))
		ensure
			instance_free: class
		end

	force_as_k_w_h (an_any: ANY): K_WATT_H
		do
			create Result.make_from_real_64 (force_as_real_64 (an_any))
		ensure
			instance_free: class
		end

	force_as_date_time (an_any: ANY): DATE_TIME
			-- Generally from JSON to Eiffel
		do
			if attached {JSON_STRING} an_any as l_s then
				if l_s.unescaped_string_8.is_integer then
					create Result.make_from_epoch (l_s.unescaped_string_8.to_integer)
				else
					create Result.make_from_string (l_s.unescaped_string_8, {JSON_UTIL}.Date_time_format)
				end
			elseif attached {DATE_TIME} an_any as l then
				Result := l
			elseif attached {JSON_NUMBER} an_any as l then
				if l.is_integer then
					create Result.make_from_epoch (l.integer_64_item.as_integer_32)
				else
					create Result.make_now_utc
					check
						couldnt_transform_type_to_date_time: False
					end
				end
			else
				create Result.make_now_utc
				check
					couldnt_transform_type_to_date_time: False
				end
			end
		ensure
			instance_free: class
		end

	force_as_date (an_any: ANY): DATE
			-- Generally from JSON to Eiffel
		do
			if attached {JSON_STRING} an_any as l_s then
				create Result.make_from_string (l_s.unescaped_string_8, {JSON_UTIL}.Date_format)
			elseif attached {DATE} an_any as l then
				Result := l
			elseif attached {DATE_TIME} an_any as l then
				Result := l.date
			else
				create Result.make_now
				check
					couldnt_transform_type_to_date_time: False
				end
			end
		ensure
			instance_free: class
		end

	force_as_real (an_any: ANY): REAL_32
		do
			if attached {REAL_32_REF} an_any as l_real then
				Result := l_real
			elseif attached {REAL_64} an_any as l_v then
				Result := l_v.truncated_to_real
			elseif attached {INTEGER} an_any as l_int then
				Result := l_int.to_real
			elseif attached {INTEGER_32_REF} an_any as l_int then
				Result := l_int.to_real
			elseif attached {INTEGER_64_REF} an_any as l_int then
				Result := l_int.to_real
			elseif attached {JSON_NUMBER} an_any as l_n then
				if l_n.is_real then
					Result := l_n.real_64_item.truncated_to_real
				elseif l_n.is_integer then
					Result := l_n.integer_64_item.to_real
				else
					check
						you_ll_have_to_code_this_case_dear: False
					end
				end
			elseif attached {JSON_STRING} an_any as l_s then
				Result := l_s.unescaped_string_8.to_real_32
			else
				check
					couldnt_transform_type_to_real: False
				end
			end
		ensure
			instance_free: class
		end

	force_as_real_64 (an_any: ANY): REAL_64
		do
			Result := force_as_real (an_any).to_double
		ensure
			instance_free: class
		end

	real_32_to_real_64 (a_real: REAL_32): REAL_64
		do
			Result := a_real.out.to_real_64
		ensure
			instance_free: class
		end

end
