note
	description: "Summary description for {VOLT}."
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	VOLT


inherit
	RANDOMABLE
		undefine
			out,
			is_equal
		redefine
			default_create
		end

	COMPARABLE
		redefine
			default_create,
			out
		end

create
	default_create,
	make_from_real,
	make_from_string,
	make_random

convert
	make_from_real ({REAL}),
	make_from_string ({STRING}),
	to_real: {REAL}

feature {NONE} -- Initialization

	default_create
		do
			set_item(0)
		end

	make_from_real (v: like item)
		require
			valid_value (v)
		do
			set_item (v)
		end

	make_from_string (v: STRING)
		require
			v_is_integer: v.is_real
			valid_v_value: valid_value (v.to_real)
		do
			set_item (v.to_real)
		end

	make_random
		local
			l_random: RANDOM
		do
			create l_random.make
			default_create
			set_item (l_random.item.to_integer_64)
		end

feature -- Status setting

	set_item (v: like item)
		require
			valid_value (v)
		do
			item := v
		end


feature -- Status report

	item: REAL

	to_real: like item
		do
			Result := item
		end

	valid_value (v: like item): BOOLEAN
		do
			Result := True
		end

	out: STRING
		do
			Result := item.out
		end


feature -- Comparable

	is_less alias "<" (other: like Current): BOOLEAN
			-- Is current object less than `other'?
		do
			Result := item < other.item
		end

invariant
	valid_value (item)

end
