note
	description: "Summary description for {WATT}."
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	WATT

inherit
	RANDOMABLE
		undefine
			is_equal
		redefine
			default_create,
			out
		end

	COMPARABLE
		redefine
			default_create,
			out
		end

	LOGGABLE
		undefine
			is_equal
		redefine
			default_create,
			out
		end

create
	default_create,
	make_from_integer_64,
	make_from_string,
	make_from_kw_string,
	make_random

convert
	make_from_integer_64 ({INTEGER_64}),
	make_from_string ({STRING}),
	to_integer_64: {INTEGER_64}

feature {NONE} -- Initialization

	default_create
		do
			set_item(0)
			Precursor {RANDOMABLE}
			Precursor {COMPARABLE}
		end

	make_from_integer_64 (v: INTEGER_64)
		require
			valid_value (v)
		do
			default_create
			set_item (v)
		end

	make_from_string (v: STRING)
		require
			v_is_integer: v.is_integer_64
			valid_v_value: valid_value (v.to_integer_64)
		do
			default_create
			set_item (v.to_integer_64)
		end

	make_from_kw_string (v: STRING)
		require
			v.is_real
		local
			l_val_i: like item
		do
--			if v.item(1).is_equal('-') then
--				logger.write_warning ("make_from_kw_string: given value is negative, transforming it but strange:" + v)
--				v.remove_head (1)
--			end
			default_create
			l_val_i := (v.to_real * 1000).truncated_to_integer_64
			set_item (l_val_i)
		end

	make_random
		local
			l_random: RANDOM
		do
			create l_random.make
			default_create
			set_item (l_random.item.to_integer_64)
		end

feature -- Status setting

	set_item (v: like item)
		require
			valid_value (v)
		do
			item := v
		end


feature -- Status report

	item: INTEGER_64

	to_integer_64: INTEGER_64
		do
			Result := item
		end

	valid_value (v: INTEGER_64): BOOLEAN
		do
			Result := True
		end

	out: STRING
		do
			Result := item.out
		end

feature -- Comparable

	is_less alias "<" (other: like Current): BOOLEAN
			-- Is current object less than `other'?
		do
			Result := item < other.item
		end

invariant
	valid_value (item)
end
