note
	description: "Summary description for {IDENTIFIABLE_MANY_TO_ONE}."
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	IDENTIFIABLE_MANY_TO_ONE[P -> RELATED_DB_ENTITY create default_create end, S -> DB_ENTITY create default_create, make_from_db_service, make_from_json, make_from_json_object end]

inherit
	MANY_TO_ONE [P, S]

	IDENTIFIABLE
		undefine
			out,
			default_create
		end

create
	make_identifiable

feature {NONE} -- Initialization

	make_identifiable (a_primary: like primary_prototype; a_secondary_required: like secondary_required; an_identifier: like identifier; a_fk: like foreign_key)
		require
			not an_identifier.is_empty
			not a_fk.is_empty
		do
			make (a_primary, a_secondary_required)
			identifier := an_identifier
			foreign_key := a_fk
		ensure
			identifier = an_identifier
			foreign_key = a_fk
		end

feature -- Status report

	to_join: JOIN
		do
			if attached {PK_DB_ENTITY} primary_prototype as l_p_pk and then
				attached {PK_DB_ENTITY} secondary_prototype as l_s_pk
			then
				-- primary to join_table
				create {INNER_JOIN} Result.make_from_fields (
					l_s_pk.table_name,
					Void,
					l_p_pk.table_name,
					identifier,
					l_s_pk.table_name,
					l_s_pk.Primary_key_db_column_name)
			else
				create {INNER_JOIN} Result
				check
					should_not_happen: False
				end
			end
		end

end
