note
	description: "Summary description for {JOIN_RELATIONSHIP}."
	author: ""
	date: "$Date$"
	revision: "$Revision$"

deferred class
	JOIN_RELATIONSHIP[P -> RELATED_DB_ENTITY create default_create end, S -> DB_ENTITY create default_create end]

inherit
	RELATIONSHIP[P, S]

feature -- Status report	

	join_table_name: STRING
		deferred
		end

    to_joins: LINKED_LIST[JOIN]
            local
                    l_join: INNER_JOIN
            do
                    create Result.make
                    if attached {PK_DB_ENTITY} primary_prototype as l_p_pk and then
                            attached {PK_DB_ENTITY} secondary_prototype as l_s_pk
                    then
                            -- primary to join_table
                            create l_join.make_from_fields (
                                    join_table_name,
                                    Void,
                                    l_p_pk.table_name,
                                    l_p_pk.Primary_key_db_column_name,
                                    join_table_name,
                                    primary_foreign_key)
                            Result.extend (l_join)
                            -- join_table to secondary
                            create l_join.make_from_fields (
                                    l_s_pk.table_name,
                                    Void,
                                    join_table_name,
                                    secondary_foreign_key,
                                    l_s_pk.table_name,
                                    l_s_pk.Primary_key_db_column_name)
                            Result.extend (l_join)
                    else
                            check
                                    should_not_happen: False
                            end
                    end
            end


    to_api_select_clauses: LINKED_LIST[STRING]
            local
                l_secondary_alias, l_as_field_name: STRING
            do
                    create Result.make
                    -- Exported fields
                    if attached {API_EXPORTABLE_ENTITY} secondary_prototype as l_s_ee and then
                            attached {PK_DB_ENTITY} secondary_prototype as l_s_pkdbe
                    then
                            if l_s_ee.api_exported_fields.is_empty then
                                    logger.write_warning ("query_from_relationships: beware, no exported field were found for " + l_s_ee.generating_type.out)
                            end
                            l_secondary_alias := l_s_pkdbe.table_name
                            -- add default id as join field
                            l_as_field_name := secondary_join_as_field_name (l_s_pkdbe.Primary_key_db_column_name)
                            Result.extend (l_secondary_alias + "." + l_s_pkdbe.Primary_key_db_column_name + " AS " + l_as_field_name)
                            -- add api_exported_fields to join
                            across
                                    l_s_ee.api_exported_fields as l_exported_field_name
                            loop
                                    l_as_field_name := secondary_join_as_field_name (l_exported_field_name.item)
                                    Result.extend (l_s_pkdbe.table_name + "." + l_exported_field_name.item + " AS " + l_as_field_name)
                            end
                    else
                            check
                                    secondary_must_be_exportable_and_not_null: False
                            end
                    end
            end


end
