note
	description: "Summary description for {ONE_TO_MANY}."
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	ONE_TO_MANY[P -> RELATED_DB_ENTITY create default_create end, S -> DB_ENTITY create default_create, make_from_db_service, make_from_json end]

inherit
	ONE_TO[P, S]
		rename
			make as make_from_primary
		redefine
			default_create
		end

	TO_MANY[P, S]
		rename
			make as make_from_secondary
		redefine
			default_create
		end

create
	make

feature {NONE} -- Initialize

	default_create
		do
			Precursor {ONE_TO}
			Precursor {TO_MANY}
		end

	make (a_primary: like primary; a_secondary_required: like secondary_required)
		do
			make_from_primary (a_primary, a_secondary_required)
		end

feature -- Status report

    to_api_select_clauses: LINKED_LIST[STRING]
            local
                l_secondary_alias, l_as_field_name: STRING
            do
                    create Result.make
                    -- Exported fields
                    if attached {API_EXPORTABLE_ENTITY} secondary_prototype as l_s_ee and then
                            attached {PK_DB_ENTITY} secondary_prototype as l_s_pkdbe
                    then
                            if l_s_ee.api_exported_fields.is_empty then
                                    logger.write_warning ("query_from_relationships: beware, no exported field were found for " + l_s_ee.generating_type.out)
                            end
                            l_secondary_alias := l_s_pkdbe.table_name
                            -- add default id as join field
                            l_as_field_name := secondary_join_as_field_name (l_s_pkdbe.Primary_key_db_column_name)
                            Result.extend (l_secondary_alias + "." + l_s_pkdbe.Primary_key_db_column_name + " AS " + l_as_field_name)
                            -- add api_exported_fields to join
                            across
                                    l_s_ee.api_exported_fields as l_exported_field_name
                            loop
                                    l_as_field_name := secondary_join_as_field_name (l_exported_field_name.item)
                                    Result.extend (l_s_pkdbe.table_name + "." + l_exported_field_name.item + " AS " + l_as_field_name)
                            end
                    else
                            check
                                    secondary_must_be_exportable_and_not_null: False
                            end
                    end
            end

end
