note
	description: "Summary description for {ONE_TO_MANY_JOIN}."
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	ONE_TO_MANY_JOIN[P -> RELATED_PK_DB_ENTITY create default_create end, S -> PK_DB_ENTITY create default_create, make_from_db_service, make_from_json end]

inherit
	ONE_TO_MANY[P, S]
		undefine
			to_api_select_clauses
		end

	JOIN_RELATIONSHIP[P, S]
		undefine
			out,
			default_create
		end
create
	make,
	make_from_join_table_name

feature {NONE} -- Initialize

	make_from_join_table_name (a_primary: like primary; a_secondary_required: like secondary_required; a_join_table_name: like join_table_name)
		do
			make (a_primary, a_secondary_required)
			set_join_table_name (a_join_table_name)
		end

feature -- Access

	join_table_name: STRING
		attribute
			Result := primary_prototype.table_name + "_" + secondary_prototype.table_name
		end

feature -- Status report


	to_constraint: CONSTRAINT
		do
			if attached {RELATED_PK_DB_ENTITY} primary as l_primary_rpk and then
				attached {PK_DB_ENTITY} secondary_prototype as l_sec
			then
				create {FIELD_CONSTRAINT} Result.make (l_primary_rpk.table_name, l_primary_rpk.Primary_key_db_column_name, {CONSTRAINT}.equal_operator, l_primary_rpk.primary_key)
				-- charge_template.id = 1
			else
				create {STRING_CONSTRAINT} Result.make ("just for compilation")
			end
		end

feature -- Status setting

	set_join_table_name (a_join_table_name: like join_table_name)
		do
			join_table_name := a_join_table_name
		ensure
			join_table_name = a_join_table_name
		end

invariant
	join_table_name.count > 0
end
