note
	description: "Summary description for {TO_MANY}."
	author: ""
	date: "$Date$"
	revision: "$Revision$"

deferred class
	TO_MANY[P -> RELATED_DB_ENTITY create default_create end, S -> DB_ENTITY create default_create, make_from_db_service, make_from_json end]

inherit
	RELATIONSHIP[P, S]
		redefine
			default_create
		end

feature {NONE} -- Initialize

	default_create
		do
			create {LINKED_LIST[S]} secondaries.make
		end

	make (a_db_connection: DB_CONNECTION)
		do
			default_create
			create secondary_db_service.make (a_db_connection)
		end


feature -- Status report

	secondaries: CHAIN[S]

	secondary_db_service: detachable DB_SERVICE[S]


feature -- Status setting

	extend (a_secondary: S)
		do
			secondaries.extend (a_secondary)
		end

	set_secondaries (an_other: like secondaries)
		do
			secondaries := an_other
		ensure
			secondaries = an_other
		end

	set_secondary_db_service (a_db_connection: DB_CONNECTION)
		do
			create secondary_db_service.make (a_db_connection)
		ensure
			attached secondary_db_service
		end

end
