note
	description: "Check if is_valid after creation"
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	REST_REQUEST_FEATURE

inherit
	FALLIBLE

create
	make_from_json_object

convert
	make_from_json_object({JSON_OBJECT})

feature -- Initialization

	make_from_json_object (a_json_object: like json_object)
			-- { "action": { "feature": "from_datetime_interval", "arg1": "some_argument" } }
		local
			l_feature_arg_key: STRING
			stop: BOOLEAN
			i: INTEGER
		do
			create arguments.make

			name := "" -- create but check validity of current object
			json_object := a_json_object
			if attached {JSON_STRING} json_object.item (Feature_key) as l_parsed_feature_s then
				name := l_parsed_feature_s.item
				if not name.is_empty then
					is_valid := True
				end
			end
			from
				i := Min_feature_arguments_index
			until
				i = Max_feature_arguments_count or stop
			loop
				l_feature_arg_key := "arg" + i.out
				if attached {JSON_STRING} json_object.item (l_feature_arg_key) as l_arg then
					arguments.extend (l_arg.unescaped_string_8)
				elseif attached {JSON_VALUE} json_object.item (l_feature_arg_key) as l_arg then
					arguments.extend (l_arg.representation)
				else
					Stop := True -- if argument not found there will be no following
				end
				i := i + 1
			end
			default_create
		end

feature -- Status report

	Min_feature_arguments_index: INTEGER = 1
	Max_feature_arguments_count: INTEGER = 10

	json_object: JSON_OBJECT

	name: STRING

	is_valid: BOOLEAN

	Feature_key: STRING = "feature"

	arguments: LINKED_LIST[STRING]

	has_arguments: BOOLEAN
		do
			Result := arguments.count > 0
		end

end
