note
	description: "Summary description for {CHARGE_UNIT_DB_SERVICE}."
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	CHARGE_UNIT_DB_SERVICE

inherit
	MEASURE_UNIT_DB_SERVICE[CHARGE_UNIT]
		redefine
			make
		end

create
	make

feature {NONE} -- Initialization

	make (a_db_connection: attached DB_CONNECTION)
		do
			Precursor (a_db_connection)
		end


feature {NONE} -- Implementation


	average_value (some_items: like items): like item.value
			-- returns a null charge if any and otherwise an average of given l_items
		local
			l_val_result: like item.value
			l_result: INTEGER
		do
			create Result
			create l_val_result
			across
				some_items as l_item
			loop
				l_val_result := l_val_result.to_integer_64 + l_item.item.value
			end
			l_result := (l_val_result.to_integer_64 / some_items.count).truncated_to_integer
			if some_items.count > 0 then
				Result.set_item (l_result)
			end
			logger.write_debug ("average_charge: " + {SIT_UTIL}.iterable_to_string(some_items) + " result:" + Result.out)
		end


end
