#!/bin/bash
. /home/pg/bin/lib/logger.sh

DEBUG="true" # let empty if not desired
BASE_URL=http://localhost:9997

# $1: entity_name
function test_get_all(){
	L_URL=${BASE_URL}/${1}
	logDebug "Request is URL:${L_URL}"
	curl -s -f --connect-timeout 3 "${L_URL}"
	if [ $? -ne 0 ]; then
		logError "Not working request URL:${L_URL} code:$?"
		curl -v --connect-timeout 3 ${L_URL}
		exit $?
	else
		logInfo "Working test '${1}' ${L_URL}"
	fi
}

# $1: entity_name
# $2: data
function test_get_feature(){
	L_URL=${BASE_URL}/${1}
	L_DATA="$2"
	logDebug "Request is POST URL:${L_URL} DATA:${L_DATA}"
	curl -s -f --connect-timeout 3 --header "Content-Type: application/json" --data "$L_DATA" "${L_URL}"
	if [ $? -ne 0 ]; then
		logError "Not working request ${L_REQUEST} code:$?"
		curl -v --header --connect-timeout 3 "Content-Type: application/json" --data "$L_DATA" "${L_URL}"
		exit $?
	else
		logInfo "Working test '${1}' ${L_URL}"
	fi
}



test_get_all company
test_get_all branch
test_get_all electricity_rate
test_get_feature electricity_rate '{"get_all":{"relationships":[{"enumerate":"city"}, {"enumerate":"electricity_type"}], "constraints": [{"distribution_company":{"id":25}}]}}' 
test_get_all charge_unit
test_get_feature charge_unit '{ "action": { "feature": "selected" }, "measuring_point": { "id": 1 } }' 
test_get_feature charge_unit '{ "action": { "feature": "items_from_date_time_interval_request", "arg1": "2018-12-14 00:00:00", "arg2": "2018-12-14 23:59:59", "arg3": "1", "arg4": "3"} }' 
test_get_all distribution_company
test_get_all enumerate
test_get_feature enumerate '{ "action": { "feature": "items_from_category_name", "arg1": "city" } }' 
test_get_feature enumerate '{ "action": { "feature": "items_sub_categories_tree_from_id", "arg1": "10" } }' 
test_get_feature enumerate '{ "action": { "feature": "items_sub_items_from_id", "arg1": "10" } }' 
test_get_all "company/branch/1"
