note
	description: "Summary description for {EXAMPLE_TEST}."
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	EXAMPLE_TEST

inherit
	REST_API_INTERFACE_TEST
		redefine
			url,
			on_prepare,
			on_clean
		end


feature {NONE} -- Events

	on_prepare
			-- <Precursor>
		do
			Precursor
		end

	on_clean
			-- <Precursor>
		do
			Precursor
		end

feature -- Access

	url: STRING
		do
			Result := "http://localhost:9997"
		end

	Sit_base_url: STRING = "http://localhost:9997"

	all_url (a_db_entity: DB_ENTITY): STRING
		do
			Result := a_db_entity.table_name
		end

	delete_url (a_db_entity: DB_ENTITY): STRING
		require
			a_db_entity.valid_for_delete
		do
			Result := a_db_entity.table_name + "/" + a_db_entity.primary_key.out
		end

	post_url (a_db_entity: DB_ENTITY): STRING
		do
			Result := a_db_entity.table_name
		end

feature -- Test

--	test_single_user_json
--			-- New test routine
--		do
--			media_type := "json"
--			if attached execute_get ("api/users/2") as l_resp then
--				assert("Expected status 200", l_resp.status = 200)
--			end
--		end

	test_entities
		local
			l_url: like url
		do
			impl_test_entity (create {COMPANY})
		end

feature {NONE} -- Entities Implementation common

	impl_test_entity (a_db_entity: DB_ENTITY)
		local
			l_url: like url
			l_db_entity, l_updated_db_entity: like a_db_entity
			l_entity_resp: DB_ENTITY_HTTP_CLIENT_RESPONSE
		do
			list_entities_test_impl (a_db_entity)
			l_db_entity := a_db_entity.deep_twin
			l_db_entity.set_random_for_insert
			check
				l_db_entity.primary_key = 0
			end
			--post (insert)
			l_url := post_url (a_db_entity)
			media_type := "json"
			if attached execute_post (l_url, a_db_entity.to_json.representation) as l_resp then
				l_entity_resp := l_resp
				assert("Expected valid_status", l_entity_resp.valid_status)
				assert_valid_entity_from_json_response (l_entity_resp, l_db_entity)

				if attached get_entity_from_response (l_resp, a_db_entity) as l_post_insert_resp_dbe then
			--update
					l_updated_db_entity := l_post_insert_resp_dbe.deep_twin
					l_updated_db_entity.set_random_for_update
					check
						l_updated_db_entity.primary_key > 0
					end
					l_url := post_url (a_db_entity)
					media_type := "json"
					if attached execute_post (l_url, l_updated_db_entity.to_json.representation) as l_update_resp then
						l_entity_resp := l_update_resp
						assert ("Expected valid_status", l_entity_resp.valid_status)
						assert_valid_entity_from_json_response (l_entity_resp, l_updated_db_entity)
					else
						assert ("post didn't return a response", False)
					end
				else
					assert ("Expected valid entity from post insert response (get_entity_from_response)", False)
				end

			else
				assert ("post didn't return a response", False)
			end

			--delete
			l_url := delete_url (a_db_entity)
			if attached execute_delete (l_url) as l_resp then
				l_entity_resp := l_resp
				assert("Expected valid_status", l_entity_resp.valid_status)
				if attached get_entity_from_id (a_db_entity) as l_e then
					assert("Expected empty result, entity should have been deleted:" + a_db_entity.primary_key.out, False)
				end
			else
				assert ("Delete didn't return a response", False)
			end
		end

	get_entity_from_id (a_db_entity: DB_ENTITY): detachable DB_ENTITY
		local
			l_db_entity: like a_db_entity
			l_json_parser: JSON_PARSER
			l_entity_resp: DB_ENTITY_HTTP_CLIENT_RESPONSE
			l_url: like url
		do
			l_url := post_url (a_db_entity)
			media_type := "json"
			if attached execute_get (l_url) as l_resp then
				l_entity_resp := l_resp
				assert("Expected valid_status", l_entity_resp.valid_status)
				Result := get_entity_from_response (l_entity_resp, a_db_entity)
			else
				assert ("Delete didn't return a response", False)
			end
		end


feature {NONE} -- Entities Test implementation list

	get_entity_from_response (an_entity_resp: DB_ENTITY_HTTP_CLIENT_RESPONSE; a_to_test_dbe: DB_ENTITY): detachable DB_ENTITY
			-- returns an entity if could be created from an_entity_resp AND valid_for_test_from_json_creation
		local
			l_json_parser: JSON_PARSER
			l_test_db_entity: TEST_DB_ENTITY
		do
			if attached an_entity_resp.body as l_body then
				create l_json_parser.make_with_string (l_body)
				l_json_parser.parse_content
				if l_json_parser.is_valid and then
					attached l_json_parser.parsed_json_value as l_parsed_json_general_obj
				then
					if attached {JSON_OBJECT} l_parsed_json_general_obj as l_json_o then
						create l_test_db_entity.make_from_json_object (l_json_o, a_to_test_dbe)
						if l_test_db_entity.valid_for_test_from_json_creation then
							Result := l_test_db_entity.db_entity
						end
					end
				end
			end
		end

	assert_valid_entity_from_json_response (an_entity_resp: DB_ENTITY_HTTP_CLIENT_RESPONSE; a_to_test_dbe: DB_ENTITY)
			-- assert l_db_entity.is_equal(l_entity_resp->body response)
		local
			l_test_db_entity: TEST_DB_ENTITY
			l_json_parser: JSON_PARSER
		do
			if attached an_entity_resp.body as l_body then
				create l_json_parser.make_with_string (l_body)
				l_json_parser.parse_content
				if l_json_parser.is_valid and then
						attached l_json_parser.parsed_json_value as l_parsed_json_general_obj
				then
					if attached {JSON_OBJECT} l_parsed_json_general_obj as l_json_o then
						create l_test_db_entity.make_from_json_object (l_json_o, a_to_test_dbe)
						assert ("Invalid entity:" + l_json_o.representation, l_test_db_entity.valid_for_test_id_not_null)
						assert ("Invalid entity valid_for_test_from_json_creation:" + l_json_o.representation, l_test_db_entity.valid_for_test_from_json_creation)
						assert ("Created entity not is_equal given entity", l_test_db_entity.db_entity.is_equal (a_to_test_dbe))
					else
						assert ("Invalid content of j_json.item, not an object:" + l_parsed_json_general_obj.representation, False)
					end
				else
					assert ("Response body is not json valid", False)
				end
			else
				assert ("Response has no body", False)
			end
		end

	list_entities_test_impl (a_db_entity: DB_ENTITY)
		local
			l_url: like url
			l_entity_resp: DB_ENTITY_HTTP_CLIENT_RESPONSE
		do
			l_url := all_url (a_db_entity)
			media_type := "json"
			if attached execute_get (l_url) as l_resp then
				l_entity_resp := l_resp
				assert("Expected valid_status", l_entity_resp.valid_status)
				assert("Valid json array", l_entity_resp.valid_json_response_array)
				assert_valid_list_entities_from_json_response (l_entity_resp, a_db_entity)
			else
				assert("Get not working, response is not attached", False)
			end
		end

	assert_valid_list_entities_from_json_response (l_entity_resp: DB_ENTITY_HTTP_CLIENT_RESPONSE; a_to_test_dbe: DB_ENTITY)
			-- Parses body response
			-- create TEST_DB_ENTITY
			-- assert if valid_for_test
		local
			l_json_parser: JSON_PARSER
			l_test_db_entity: TEST_DB_ENTITY
		do
			if attached l_entity_resp.body as l_body then
				create l_json_parser.make_with_string (l_body)
				l_json_parser.parse_content
				if l_json_parser.is_valid and then
						attached l_json_parser.parsed_json_value as l_parsed_json_general_obj
				then
					if attached {JSON_ARRAY} l_parsed_json_general_obj as l_json_array then
						across
							l_json_array as l_json_e
						loop
							if attached {JSON_OBJECT} l_json_e.item as l_json_o then
								create l_test_db_entity.make_from_json_object (l_json_o, a_to_test_dbe)
								assert ("Invalid entity:" + l_json_o.representation, l_test_db_entity.valid_for_test_id_not_null)
							else
								assert ("Invalid content of j_json.item, not an object:" + l_json_e.item.representation, False)
							end
						end
					end
				else
					assert ("Response body is not json valid", False)
				end
			else
				assert ("Response has no body", False)
			end
		end

feature {NONE} -- Entities Test implementation create

	create_entity_test_impl (a_db_entity: DB_ENTITY)
		require
			a_db_entity.valid_for_insert
		do

		end

end
