note
	description: "Summary description for {DB_ENTITY_HTTP_CLIENT_RESPONSE}."
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	DB_ENTITY_HTTP_CLIENT_RESPONSE

inherit
	HTTP_CLIENT_RESPONSE

create
	make_from_http_client_response

convert
	make_from_http_client_response ({HTTP_CLIENT_RESPONSE})

feature -- Initialization

	make_from_http_client_response (a_client_response: HTTP_CLIENT_RESPONSE)
		do
			make (a_client_response.url)
			set_body (a_client_response.body)
			set_http_version (a_client_response.http_version)
			set_error_occurred (a_client_response.error_occurred)
			if attached a_client_response.error_message as l then
				set_error_message (l)
			end

			set_raw_header (a_client_response.raw_header)
			set_status_line (a_client_response.status_line)
		end

feature -- Status report

	valid_status: BOOLEAN
		do
			Result := status = 200
		end

	valid_json_response: BOOLEAN
			-- is response a valid json
		local
			l_json_parser: JSON_PARSER
		do
			if attached body as l_body then
				create l_json_parser.make_with_string (l_body)
				l_json_parser.parse_content
				Result := l_json_parser.is_valid
			end
		end

	valid_json_response_array: BOOLEAN
			-- is response a valid json array
		local
			l_json_parser: JSON_PARSER
		do
			if attached body as l_body then
				create l_json_parser.make_with_string (l_body)
				l_json_parser.parse_content
				if l_json_parser.is_valid and then
						attached l_json_parser.parsed_json_value as l_parsed_json_general_obj
				then
					if attached {JSON_ARRAY} l_parsed_json_general_obj as l_json_object then
						Result := True
					end
				end
			end
		end

--			if l_json_parser.is_valid
--					and then attached l_json_parser.parsed_json_value as l_parsed_json_val then
--				if attached {JSON_OBJECT} l_parsed_json_val as l_json_object then
--					across
--						l_json_object as l_json_sub_val
--					until
--						has_error
--					loop
--						l_type_or_ident_s := l_json_sub_val.key.unescaped_string_32


end
