note
	description: "Summary description for {REST_API_INTERFACE_TEST}."
	date: "$Date$"
	revision: "$Revision$"

class
	REST_API_INTERFACE_TEST


inherit
	EQA_TEST_SET

	HTTP_CLIENT_TEST_HELPER
		undefine
			default_create
		redefine
			context_executor
		end


feature -- Context Executor

	media_type: detachable STRING
			-- media type (text/html, etc)


	context_executor: HTTP_CLIENT_REQUEST_CONTEXT
			-- context executor to get predefined media types
		local
			l_ctx_factory: HTTP_CLIENT_CONTEXT_FACTORY
		do
			create l_ctx_factory
			if attached media_type as l_media_type and then l_media_type.same_string("html") then
				Result := l_ctx_factory.text_context_executor
			elseif attached media_type as l_media_type and then l_media_type.same_string("json") then
				Result := l_ctx_factory.json_context_executor
			else
				Result := l_ctx_factory.unknown_context_executor
			end

		end

end
